<?php

namespace Intuit\Models;

use Illuminate\Database\Eloquent\Model;
use Laravel\Socialite\Facades\Socialite;

class ProviderToken extends Model
{
	protected $dates = [
		'access_token_expires_at',
		'refresh_token_expires_at',
	];

	/* ATTRIBUTES */

	public function getAccessTokenAttribute($value): ?string
	{
		if (! $this->hasAccessTokenExpired())
			return $value;

		// Auto refresh the token
		$this->refreshToken();

		return (! $this->hasAccessTokenExpired()) ? $this->getRawOriginal('access_token') : NULL;
	}

	/* METHODS */

	public function hasAccessTokenExpired(): bool
	{
		return $this->access_token_expires_at->isPast();
	}

	public function refreshToken(): bool
	{
		return Socialite::with($this->provider->name)->refreshtoken($this);
	}
}